library seamless;

import 'package:flutter/material.dart';

class Seamless extends StatelessWidget {
  final WidgetBuilder mobile;
  final WidgetBuilder tablet;
  final WidgetBuilder desktop;

  static const int _small = 576;
  static const int _medium = 768;
  //static const int _large = 992;
  //static const int _extra_large = 1200;

  WidgetBuilder _getTablet() {
    return tablet ?? mobile;
  }

  WidgetBuilder _getDesktop() {
    return desktop ?? _getTablet();
  }

  Seamless({@required this.mobile, this.tablet, this.desktop});

  @override
  Widget build(BuildContext context) {
    final pixelRatio = MediaQuery.of(context).devicePixelRatio;
    return LayoutBuilder(
      builder: (c, sz) {
        final w = sz.biggest.width.toDouble() / pixelRatio;

        if (w <= _small) return mobile(context);
        if (w <= _medium) return _getTablet()(context);
        return _getDesktop()(context);
      },
    );
  }
}
